C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   SUBROUTINE     - INCSTO                                                    +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           RETURNS THE MAXIMUM DIMENSION OF THE REAL WORKING ARRAY AWRK OF    +
C           THE COMMON /WRKSPR/. THIS SUBROUTINE PERMITS TO CHANGE THE VALUE   +
C           SET IN THE SUBROUTINES COMPOS AND SELECT.                          +
C           TO PERFORMS THIS, THE USER MUST INCLUDE IN THE CALLING PROGRAM     +
C           THE INSTRUCTIONS                                                   +
C                PARAMETER (MAXASZ=xxxxx)                                      +
C                DOUBLE PRECISION AWRK(MAXASZ)                                 +
C                COMMON /WRKSPR/ AWRK                                          +
C           WHERE xxxxx IS A CONSTANT GREATER THAN 1000 (THE VALUE FIXED IN    +
C           THE SUBROUTINES INVOLVED) THAT DEFINES THE NEW MAXIMUM SIZE.       +
C           AFTER HE MUST CALL THIS SUBROUTINE IN THE FOLLOWING WAY            +
C                IDIM = MAXASZ                                                 +
C                CALL INCSTO(IDIM)                                             +
C                                                                              +
C   USAGE:                                                                     +
C           CALL INCSTO (IDIM)                                                 +
C                                                                              +
C   ARGUMENTS:                                                                 +
C                                                                              +
C           IDIM   - INPUT/OUTPUT INTEGER. IT REPRESENTS THE MAXIMUM DIMENSION +
C                    OF THE REAL WORKING ARRAY AWRK.                           +
C                    IF ITS VALUE IS LESS THAN 1000, IT IS CHANGED TO 1000.    +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE INCSTO (IDIM)
C
C                        ... SPECIFICATIONS FOR ARGUMENTS
C
      INTEGER*4 IDIM
C
C                        ... SPECIFICATIONS FOR LOCAL VARIABLES AND
C                            CONSTANTS
C
      INTEGER*4 OLDIM, FIXDIM
      SAVE OLDIM
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (FIXDIM = 1000)
C
C                        ... DATA STATEMENTS
C
      DATA OLDIM /0/
C
C                        ... EXECUTABLE STATEMENTS
C
      IF (IDIM .LT. FIXDIM) IDIM = FIXDIM
      IF (IDIM .EQ. FIXDIM) THEN
         IF (OLDIM .EQ. 0) THEN
            OLDIM = FIXDIM
         ELSE
            IDIM  = OLDIM
         END IF
      ELSE
         OLDIM = IDIM
      END IF
      RETURN
      END
