C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MBLBORD                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE BLBORD (BLOCK BORDERING).      +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINES                 BLBORD, BETABOR, GAUSS, INVERS, RCPROD  +
C       -  DOUBLE PRECISION FUNCTION   INNERG                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                       
      PROGRAM MBLBORD
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      DOUBLE PRECISION EPS
      INTEGER I, IER, INIT, IR, J, NBC
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (NBC=7, IR=7, EPS=1.0D-31)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION A(IR,IR), D(IR), Z(IR), WK(IR), BETA(IR,2*IR)
C
C                        ... DATA STATEMENTS
C
      DATA A/
     *  3 * 1.0D0 , -1.0D0, 3 * 0.0D0, 
     *  4 * 1.0D0, 3 * 0.0D0, 
     *  1.0D0, 2.0D0, -1.0D0, 2.0D0, 3 * 0.0D0,
     *  1.0D0, 6 * 0.0D0, 
     *  -1.0D0, 1.0D0, 2.0D0, -1.0D0, 2 * 1.0D0, -1.0D0,
     *  0.0D0, 1.0D0, -2.0D0, 3 * 1.0D0, 0.0D0,
     *  2 * -1.0D0, 0.0D0, 2 * 2.0D0, 1.0D0, 2.0D0/
      DATA D/
     *  -2.0D0, 13.0D0, -2.0D0, 22.0D0, 25.0D0, 18.0D0, 9.0D0/
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MBLBORD'
      WRITE (*,100) ' DIMENSION OF THE SYSTEM', NBC
      WRITE (*,200) ' MATRIX A ','VECTOR D'
      DO 10 I = 1, NBC
        WRITE (*,300) (A(I,J), J=1,NBC), D(I)
   10 CONTINUE
      WRITE (*,*) 
      WRITE (*,*) ' THE SOLUTION IS (1, 2, 3, 4, 5, 6, 7) '
      WRITE (*,*) ' THE SUB-SYSTEMS OF DIMENSION 2,3 AND 6 ARE SINGULAR'
C
      INIT = 0
      DO 20 I = 1, NBC
	 WRITE (*,*)
	 WRITE (*,100) ' SUB-SYSTEM OF DIMENSION ', I
C
C                        ... CALL BLBORD
C
         CALL BLBORD (A, D, IR, Z, BETA, WK, EPS, INIT, IER)
C
         IF (IER .NE. 0 .AND. IER .NE. 2100) THEN
            WRITE (*,*) ' STOP DUE TO ERROR', IER
            STOP
         END IF
         IF (IER .NE. 2100) THEN
	    WRITE(*,*) ' SOLUTION '
            WRITE(*,*) (Z(J),J=1,I)
         ELSE
            WRITE (*,*) ' SINGULAR MATRIX '
            IER = 0
         END IF 
   20 CONTINUE
      STOP
  100 FORMAT (/T2,A,I3)
  200 FORMAT (/T2,A,T68,A)
  300 FORMAT ((7F8.4),F20.0)
      END      
