C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MBORDER                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE BORDER.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINES                 BORDER, QBORD                           +
C       -  DOUBLE PRECISION FUNCTION   INNERC                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                       
      PROGRAM MBORDER 
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      DOUBLE PRECISION EPS
      INTEGER I, IER, INIT, IR, J, NBC
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (NBC=5, IR=10, EPS=1.0D-31)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION A(IR,IR), D(IR), Z(IR), Q(IR*(IR+3)/2)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MBORDER'
      WRITE (*,100) ' DIMENSION OF THE SYSTEM', NBC
      DO 20 I = 1, NBC
	 D(I) = 0.0D0
	 DO 10 J = 1, NBC
	    A(I,J) = 1.0D0 / (I + J - 1.0D0)
	    D(I)   = D(I) + J * A(I,J)
   10    CONTINUE
   20 CONTINUE
C
      INIT = 0
      DO 30 I = 1, NBC
C
C                        ... CALL BORDER
C
         CALL BORDER (A, D, IR, Z, Q, EPS, INIT, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO ERROR', IER
            IF (IER .EQ. 100) THEN
               WRITE(*,*)' DIVISION BY ZERO. THE BLOCK BORDERING METHOD'
               WRITE(*,*)' MUST BE USED, SEE THE SUBROUTINE BLBORD.'
            END IF
            STOP
         END IF
	 WRITE(*,100) ' SOLUTION FOR I=', I
         WRITE(*,*) (Z(J),J=1,I)
   30 CONTINUE
      STOP
  100 FORMAT(/T2,A,I3/)
      END      
