C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MCOMPOS                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE COMPOS.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINES  ARRSTO, COMPOS, EALGO, EPSRHA, IDELTA, INCSTO,         +
C                       LEVINT, OVERHO, RICHAR, THETA                          +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MCOMPOS
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, INIT, J, M, N, NBC, NBMTR, NDIGIT, NTR
      DOUBLE PRECISION A, AERR, EPS, SINIT, SLIMIT, SSAV
      CHARACTER*1 CT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (NTR=9, NBC=20, NBMTR=9, EPS=1.0D-30, NDIGIT=12)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER IER(NBMTR+2), IOR(NBMTR), ITOR(NTR)
      DOUBLE PRECISION ANDIG(0:NBMTR), E(0:NTR-1), RES(NTR)
C
C                        ... DATA STATEMENTS
C
      DATA IOR /1, 9, 3, 7, 8, 5, 2, 6, 4/
      DATA CT /'T'/
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MCOMPOS',
     *            ' (NUMBER OF SIGNIFICANT DIGITS)'
C
      WRITE (*,100) (IOR(I), I=1, NBMTR)
C
      A  =  3.0D0
C
C                        ... DEFINE THE LIMIT S
C
      SLIMIT = 0.0D0
C
      INIT = 0
      DO 50 N = 1, NBC 
C
C                        ... COMPUTATION OF S
C                                            N
C
         SINIT = DSIN(A*N)/DBLE(N)
         SSAV  = SINIT
C
C                        ... CALL COMPOS
C
         CALL COMPOS (E, NBC, INIT, EPS, SINIT, IOR, NTR, RES, 
     *      NDIGIT, IER)
C
         IF (IER(11) .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER(11)
            IF (IER(11).EQ.1000) THEN
              WRITE (*,200) 'IER',' ', (CT,I=1,NTR),'EALGO'
              WRITE (*,300) (I,I=1,NBMTR)
              WRITE (*,*)
              WRITE (*,300) (IER(I),I=1,NBMTR+1)
            END IF
            IF (IER(10).EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE EALGO'
            STOP
         END IF
C
         IF (N .EQ. 1) THEN
C
C                        ... DEFINE THE OUTPUT ORDER OF THE
C                            TRANSFORMATIONS
C
            DO 20 I = 1, NTR
               DO 10 J= 1, NBMTR
                  IF (I .EQ. IOR(J)) ITOR(I)=J
   10          CONTINUE
   20       CONTINUE
         WRITE (*,200) 'IT.', 'S', (CT,I=1,NTR)
         WRITE (*,300) (ITOR(I),I=1,NTR)
         END IF
C
         IF (N .GE. 4) THEN
C
C                        ... COMPUTE THE RELATIVE ERROR FOR S
C                                                            N
C
            AERR = DABS(SSAV-SLIMIT)
            IF (DABS(SLIMIT) .NE. 0.0D0) AERR = AERR/DABS(SLIMIT)
            IF (AERR .EQ. 0.0D0) THEN
               ANDIG(0) = 99.0D0
            ELSE
               ANDIG(0) = -DLOG10(AERR)
            END IF
C
C                        ... COMPUTE THE RELATIVE ERROR FOR THE RESULTS
C                            OF THE TRANSFORMATIONS USED
C
            DO 30 I = 1, NTR
               AERR = DABS(RES(I)-SLIMIT)
               IF (DABS(SLIMIT) .NE. 0.0D0) AERR = AERR/DABS(SLIMIT)
               IF (AERR .EQ. 0.0D0) THEN
                  ANDIG(I) = 99.0D0
               ELSE
                  ANDIG(I) = -DLOG10(AERR)
               END IF
   30       CONTINUE
            WRITE (*,400) N, (ANDIG(I), I=0,NTR)
            M = MIN0(N-4,NTR-1)
            DO 40 I = 0, M
               AERR = DABS(E(I)-SLIMIT)
               IF (DABS(SLIMIT) .NE. 0.0D0) AERR = AERR/DABS(SLIMIT)
               IF (AERR .EQ. 0.0D0) THEN
                  ANDIG(I) = 99.0D0
               ELSE
                  ANDIG(I) = -DLOG10(AERR)
               END IF
   40       CONTINUE
            WRITE (*,500) 'EALGO', (ANDIG(I), I=0,M)
         END IF
   50 CONTINUE
C
      STOP
  100 FORMAT(/'  ORDER OF THE TRANSFORMATIONS:',9I3)
  200 FORMAT(/T3,A,T9,A,T15,A,T22,A,T29,A,T36,A,T43,A,T50,A,T57,A,
     *       T64,A,T71,A,T75,A)
  300 FORMAT(T10,10I7)
  400 FORMAT(/I4,10F7.2)
  500 FORMAT(T3,A,T12,9F7.2)
      END
