C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MCRPA                                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE CRPA.                          +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE   CRPA                                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MCRPA
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IALG, IER, INIT, IP, IR, MAXC, MAXCOL, N, NBC
      DOUBLE PRECISION A, B, EPS
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=7, IR=10, IP=5, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION E(IR,0:MAXCOL), XINIT(IR), ZINIT(IR,MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
      MAXC = MAXCOL
      WRITE (*,*) ' OUTPUT RESULTS FROM MCRPA'
      WRITE (*,100) ' DIMENSION OF THE VECTORS ',IP
C
C                        ... LOOP FOR THE THREE ALGORITHMS
C
C                            IALG = 0  CRPA
C                            IALG = 1  ITS FIRST VARIANT
C                            IALG = 2  ITS SECOND VARIANT
C
      DO 30 IALG = 0, 2
         WRITE (*,100) ' VARIANT', IALG
         WRITE (*,*) ' ITER.    XINIT OUTPUT'
         WRITE (*,*)
C
         INIT = 0
         DO 20 N = 1, NBC
            DO 10 I = 1, IP
               A        = DBLE(I)
               B        = DBLE(N)
               XINIT(I) = DCOS(A) / B**I
               IF (N .NE. 1 .AND. N .LE. MAXCOL+1) 
     *                         ZINIT(I,N-1) = DSIN(A*B)
   10       CONTINUE
C
C                        ... CALL CRPA
C
            CALL CRPA (E, MAXC, INIT, EPS, XINIT, ZINIT, 
     *          IR, IP, IALG, IER)
C
            IF (IER .NE. 0) THEN
               WRITE (*,*) ' NON ZERO IER =',IER
               IF (IER .EQ. 2000) THEN
                  WRITE (*,*) ' MAXCOL GREATER THAN IP'
                  IER = 0
               ELSE
                  IF (IER .EQ. 100) 
     *            WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE CRPA'
                  STOP
               END IF
            END IF
C
            WRITE (*,200) N, (XINIT(I), I=1,IP)
   20    CONTINUE
   30 CONTINUE
      STOP
  100 FORMAT(/T2,A,I3)
  200 FORMAT(I6,(T9,3D24.16))
      END
