C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MEPSRHA                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE EPSRHA.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    EPSRHA                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MEPSRHA
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, INIT, MAXC, MAXCOL, MAXSIN, N, NBC, NDIGIT
      DOUBLE PRECISION EPS
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=6, MAXSIN=3, NBC=10, NDIGIT=10, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER IER(0:3), INDSAV(0:3,MAXSIN), NSING(0:3)
      DOUBLE PRECISION EPSVEC(0:3,0:MAXCOL), ABVEC(0:3,2*MAXSIN), 
     *          EPSINI(0:3), XAUX(3,0:MAXCOL), XINIT(3), TMP(0:3)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MEPSRHA'
C
      INIT = 0
      MAXC = MAXCOL
      DO 30 N = 1, NBC
         WRITE (*,100) ' ITERATION', N, 'ALGORITHM', 
     *      'EPSINI INPUT', 'EPSINI OUTPUT', 'N.SING.'
C
C                            I = 0  EPSILON-ALGORITHM
C                            I = 1  FIRST GEN. EPSILON-ALGORITHM
C                            I = 2  SECOND GEN. EPSILON-ALGORITHM
C                            I = 3  RHO-ALGORITHM
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE 
C                            SEQUENCES (S ) FOR EACH ALGORITHM
C                                        n
C
         EPSINI(0) = DBLE(N**2) * 0.8D0**N
         EPSINI(1) = 1.0D0/DBLE(N)
         EPSINI(2) = DSIN(0.8D0*N**2) * 0.9D0**(N**2)
         EPSINI(3) = 1.0D0/DBLE(N**3)
         DO 10 I = 0, 3
            TMP(I) = EPSINI(I)
   10    CONTINUE
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE 
C                            AUXILIARY SEQUENCE (x ) 
C                                                 n
C
         XINIT(1) = N
         XINIT(2) = N**2
         XINIT(3) = N
C
C                        ... CALL EPSRHA
C
         CALL EPSRHA (EPSVEC, MAXC, INIT, EPS, EPSINI, NDIGIT,
     *      MAXSIN, NSING, INDSAV, ABVEC, XAUX, XINIT, IER)
C
         DO 20 I = 0, 3
            IF (IER(I) .NE. 0) THEN
               WRITE (*,300) I, ' NON ZERO IER =',IER(I)
               IF (IER(I).EQ.100) 
     *           WRITE (*,400) 
     *           ' DIVISION BY ZERO IN THE SUBROUTINE EPSRHA'
               IF (IER(I).EQ.1100) 
     *           WRITE (*,400) ' TOO MANY SINGULARITIES'
               IF (IER(I).EQ.1200) 
     *           WRITE (*,400) ' SINGULARITY NON ISOLATED'
            ELSE
               WRITE (*,200) I, TMP(I), EPSINI(I), NSING(I)
            END IF
   20    CONTINUE
   30 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST EPSVEC VECTOR'
      WRITE (*,*)
      DO 40 I = 0, 3
         IF (IER(I) .EQ. 0) THEN
            WRITE (*,*) ' ALGORITHM', I
            WRITE (*,*) (EPSVEC(I,N), N=0,MAXC)
            WRITE (*,*)
         END IF
   40 CONTINUE
      STOP
  100 FORMAT (/T32,A,I3//T3,A,T27,A,T52,A,T68,A/)
  200 FORMAT (I12,2D26.16,I10)
  300 FORMAT (I12,T15,A,I6)
  400 FORMAT (T15,A)
      END
