C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MEPSRHO                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE EPSRHO.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    EPSRHO                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MEPSRHO
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IALG, IER, INIT, MAXC, MAXCOL, MAXSIN, N, 
     *          NBC, NDIGIT, NSING
      DOUBLE PRECISION EPS, EPSINI, TMP, XINIT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=4, MAXSIN=1, NBC=10, NDIGIT=10,
     *          EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER INDSAV(MAXSIN)
      DOUBLE PRECISION EPSVEC(0:MAXCOL), ABVEC(2*MAXSIN), 
     *          XAUX(0:MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
C
C                        ... CHOICE OF THE ALGORITHM:
C
C                            IALG = 0  EPSILON-ALGORITHM
C                            WE NEED XINIT AND XAUX(0:MAXCOL) FOR
C                            IALG = 1  FIRST GEN. EPSILON-ALGORITHM
C                            IALG = 2  SECOND GEN. EPSILON-ALGORITHM
C                            IALG = 3  RHO-ALGORITHM
C                                                   
      IALG = 3
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MEPSRHO'
      WRITE (*,100) ' ITERATION', 'EPSINI INPUT', 'EPSINI OUTPUT',
     *      'N.SING.'
C
      INIT = 0
      MAXC = MAXCOL
      DO 10 N = 1, NBC
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE 
C                            AUXILIARY SEQUENCE (x )
C                                                 n
C
         XINIT = DLOG(DBLE(N)+1.0D0)
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE 
C                            SEQUENCE (S )
C                                       n
C
         EPSINI = 1.0D0/XINIT**2
         TMP    = EPSINI
C
C                        ... CALL EPSRHO
C
         CALL EPSRHO (EPSVEC, MAXC, INIT, EPS, EPSINI, NDIGIT,
     *      MAXSIN, NSING, INDSAV, ABVEC, XAUX, XINIT, IALG, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE EPSRHO'
            IF (IER.EQ.1100) 
     *        WRITE (*,*) ' TOO MANY SINGULARITIES'
            IF (IER.EQ.1200) 
     *        WRITE (*,*) ' SINGULARITY NON ISOLATED'
            STOP
         END IF
C
         WRITE (*,200) N, TMP, EPSINI, NSING
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST EPSVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (EPSVEC(I), I=0,MAXC)
      STOP
  100 FORMAT (/T3,A,T27,A,T52,A,T68,A/)
  200 FORMAT (I12,2D26.16,I10)
      END
