C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MEPSTOP                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE EPSTOP.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE                 EPSTOP                                   +
C       -  DOUBLE PRECISION FUNCTION  INNERP                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MEPSTOP
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, IP, IR, MAXC, MAXCOL, N, NBC
      DOUBLE PRECISION EPS 
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=6, NBC=10, IR=5, IP=3, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION EPSMAT(IR,0:MAXCOL), EPSINI(IR), Y(IR),
     *            WG(4*IR)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MEPSTOP'
      WRITE (*,*)
      WRITE (*,*) ' ITER.  EPSINI OUTPUT'
      WRITE (*,*)
C
      DO 10 I = 1, IP
         Y(I) = 1.0D0
   10 CONTINUE
C
      INIT = 0
      MAXC = MAXCOL
      DO 30 N = 1, NBC
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE SEQUENCE
C
         DO 20 I = 1, IP
            EPSINI(I) = I*0.8D0**N + N*0.9D0**N
   20    CONTINUE
C
C                        ... CALL EPSTOP
C
         CALL EPSTOP (EPSMAT, MAXC, INIT, EPS, EPSINI, Y,
     *      IR, IP, WG, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE EPSTOP'
            STOP
         END IF
C
         WRITE (*,100) N, (EPSINI(I), I=1,IP)
   30 CONTINUE
      STOP
  100 FORMAT (I6,(T9,3D24.16))
      END
