C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MEPSVEC                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE EPSVEC.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE                 EPSVEC                                   +
C       -  DOUBLE PRECISION FUNCTION  ENORM2                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MEPSVEC
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, IP, IR, MAXC, MAXCOL, MAXSIN, N, 
     *          NBC, NDIGIT, NSING
      DOUBLE PRECISION EPS 
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=6, MAXSIN=3, NBC=10, NDIGIT=10,
     *          IR=5, IP=3, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER INDSAV(MAXSIN)
      DOUBLE PRECISION EPSMAT(IR,0:MAXCOL), EPSINI(IR), SVAL(3*MAXSIN),
     *          ABMAT(IR,2*MAXSIN), WG(4*IR)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MEPSVEC'
      WRITE (*,*)
      WRITE (*,*) ' IT. N.SING. EPSINI OUTPUT'
      WRITE (*,*)
C
      INIT = 0
      MAXC = MAXCOL
      DO 20 N = 1, NBC
C
C                        ... COMPUTATION OF THE N-TH TERM OF THE SEQUENCE
C
         DO 10 I = 1, IP
            EPSINI(I) = I*0.8D0**N + N*0.9D0**N
   10    CONTINUE
C
C                        ... CALL EPSVEC
C
         CALL EPSVEC (EPSMAT, MAXC, INIT, EPS, EPSINI, IR, IP,
     *      NDIGIT, MAXSIN, NSING, INDSAV, ABMAT, WG, SVAL, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE EPSVEC'
            IF (IER.EQ.1100) 
     *        WRITE (*,*) ' TOO MANY SINGULARITIES'
            IF (IER.EQ.1200) 
     *        WRITE (*,*) ' SINGULARITY NON ISOLATED'
            STOP
         END IF
C
         WRITE (*,100) N, NSING, (EPSINI(I), I=1,IP)
   20 CONTINUE
      STOP
  100 FORMAT (I4,I6,(T12,3D23.15))
      END
