C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MIDELTA                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE IDELTA.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    IDELTA                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MIDELTA
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, MAXCOL, NBC
      DOUBLE PRECISION EPS, X, XINIT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=15, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION XVEC(0:2*MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MIDELTA'
      WRITE (*,100) ' ITERATION', 'XINIT INPUT', 'XINIT OUTPUT'
      INIT = 0
C
      DO 10 I = 1, NBC
         X     = 1.0D0/DBLE(I)
         XINIT = X
C
C                        ... CALL IDELTA
C
         CALL IDELTA (XVEC, MAXCOL, INIT, EPS, XINIT, IER) 
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE IDELTA'
            STOP
         END IF
C
         WRITE (*,*) I, X, XINIT
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST XVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (XVEC(I), I=0, 2*MAXCOL)
C
  100 FORMAT (/T3,A,T27,A,T51,A/)
      STOP
      END
