C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MLEVINT                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE LEVINT.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    LEVINT                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MLEVINT
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, ITRAN, MAXCOL, NBC
      DOUBLE PRECISION A, B, EPS, LINIT, GINIT, X
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=10, NBC=15, EPS=1.0D-30, B=1.0D0)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION VECN(0:MAXCOL), VECD(0:MAXCOL), S(-1:NBC-1)
C
C                        ... EXECUTABLE STATEMENTS
C
C
C                        ... SET THE X VALUE
C
      X = 1.0D0
C
C                        ... COMPUTE THE SEQUENCE (S  )
C                                                   n
      S(-1) = 0.0D0
      S(0)  = X
      A     = X
      DO 10 I = 1, NBC-1
         A    = -A * X
         S(I) = S(I-1) + A/DBLE(I+1)
   10 CONTINUE
C
C                        ... CHOICE THE TRANSFORMATION:
C                            ITRAN = 0  WE MUST SUPPLY THE GINIT VALUE
C                            ITRAN = 1  u-TRANSFORM
C                            ITRAN = 2  t-TRANSFORM
C                            ITRAN = 3  v-TRANSFORM
C                                                   
      ITRAN = 1    
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MLEVINT'
      WRITE (*,*) 
      WRITE (*,*) '  X', X, '       LIMIT', DLOG(1.0D0+X)
      WRITE (*,100) ' ITERATION', ' LINIT INPUT', ' LINIT OUTPUT'
C
      INIT = 0
      DO 20 I = 1, NBC
         LINIT = S(I-1)
C
C                        ... CALL LEVINT
C
         CALL LEVINT (VECN, VECD, MAXCOL, INIT, EPS, LINIT, GINIT,
     *               B, ITRAN, IER)  
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *         WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE LEVINT'
            STOP
         END IF
C
         WRITE (*,200) I, S(I-1), LINIT
   20 CONTINUE
      IF (MAXCOL .NE. 0) THEN
         WRITE (*,*)
         WRITE (*,*) ' LAST ROW OF THE L-ARRAY'
         WRITE (*,*)
         WRITE (*,*) (VECN(I)/VECD(I), I=0,MAXCOL)
      END IF
C
      STOP
  100 FORMAT (/T3,A,T27,A,T52,A/)
  200 FORMAT (I12,2D26.16)
      END
