C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MTHETA                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE THETA.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    THETA                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MTHETA
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, MAXC, MAXCOL, NBC
      DOUBLE PRECISION EPS, THINIT, THPREC
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=8, NBC=15, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION THVEC(0:2*MAXCOL)
C
C                        ... SPECIFICATION FOR STATEMENT FUNCTIONS
C
      DOUBLE PRECISION X, FUN
      FUN(X) = DLOG(1.0D0+X)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MTHETA'
      WRITE (*,100) ' ITERATION', 'THINIT INPUT', 'THINIT OUTPUT'
C
      INIT   = 0
      MAXC   = MAXCOL
      THINIT = 1.0D0
      THPREC = 1.0D0
C
      DO 10 I = 1, NBC
C
C                        ... CALL THETA
C
         CALL THETA (THVEC, MAXC, INIT, EPS, THINIT, IER)  
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE THETA'
            STOP
         END IF
C
         WRITE (*,200) I, THPREC, THINIT
         IF (I .NE. NBC) THEN
            THINIT  = FUN(THPREC)
            THPREC  = THINIT
         END IF
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST THVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (THVEC(I), I=0,2*MAXC)
C
  100 FORMAT (/T3,A,T27,A,T52,A/)
  200 FORMAT (I12,2D26.16)
      STOP
      END
